package com.ym.mec.biz.dal.entity;

import com.ym.mec.biz.dal.dto.StudentLessonTrainingDetailWrapper;
import com.ym.mec.biz.dal.enums.ELessonTrainingType;
import com.ym.mec.biz.dal.enums.GroupType;
import com.ym.mec.biz.dal.enums.ImSendTypeEnum;
import com.ym.mec.biz.dal.enums.StandardEnum;
import com.ym.mec.biz.dal.enums.YesOrNoEnum;
import com.ym.mec.common.entity.BaseEntity;

import io.swagger.annotations.ApiModelProperty;

import org.apache.commons.lang3.builder.ToStringBuilder;

import java.util.Date;
import java.util.List;

/**
 * 对应数据库表(student_course_homework):
 */
public class StudentCourseHomework extends BaseEntity {

	/**  */
	private Long id;

	@ApiModelProperty(value = "学生ID",required = false)
	private Integer userId;

	@ApiModelProperty(value = "用户名")
	private String userName;

	@ApiModelProperty(value = "手机号")
	private String phone;

	@ApiModelProperty(value = "头像")
	private String avatar;
	
	/**  */
	@ApiModelProperty(value="作业编号")
	private Long courseHomeworkId;

	@ApiModelProperty(value="课程编号")
	private Long courseScheduleId;
	
	private CourseHomework courseHomework = new CourseHomework();
	
	/** 作品附件 */
	@ApiModelProperty(value="作品附件")
	private String attachments;
	
	/** 评分 */
	@ApiModelProperty(value="评分")
	private Integer score;
	
	/**  */
	private java.util.Date createTime;
	
	/**  */
	private java.util.Date updateTime;

	private boolean extra;

	@ApiModelProperty(value="提交时间")
	private Date submitTime;

    @ApiModelProperty(value="类型")
    private GroupType groupType;

	private ImSendTypeEnum msgType = ImSendTypeEnum.TXT;

	//伴奏编号
	@ApiModelProperty(value="伴奏编号")
	private String musicScoreId;

	//伴奏编号
	@ApiModelProperty(value="伴奏编号（包含分谱信息）")
	private String musicScoreContent;

	//伴奏编号
	@ApiModelProperty(value="伴奏名称")
	private String musicScoreName;

	@ApiModelProperty(value = "0未达标、1达标、2优秀",required = true)
	private StandardEnum standardFlag;

    @ApiModelProperty("完成状态")
    private Boolean  finishFlag;

    @ApiModelProperty("是否是vip")
    private Boolean vipFlag;

    @ApiModelProperty("声部id")
    private Integer subjectId;

    @ApiModelProperty("声部名称")
    private String subjectName;

    @ApiModelProperty(value = "作业类型 来源（HOMEWORK,EXTRACURRICULAR,EXTRA）",required = true)
    private ELessonTrainingType type;

    @ApiModelProperty(value = "练习内容")
    private List<StudentLessonTrainingDetailWrapper.StudentLessonTrainingDetail> studentLessonTrainingDetail;

    public List<StudentLessonTrainingDetailWrapper.StudentLessonTrainingDetail> getStudentLessonTrainingDetail() {
        return studentLessonTrainingDetail;
    }

    public void setStudentLessonTrainingDetail(List<StudentLessonTrainingDetailWrapper.StudentLessonTrainingDetail> studentLessonTrainingDetail) {
        this.studentLessonTrainingDetail = studentLessonTrainingDetail;
    }

    public ELessonTrainingType getType() {
        return type;
    }

    public void setType(ELessonTrainingType type) {
        this.type = type;
    }

    public Boolean getFinishFlag() {
        return finishFlag;
    }

    public void setFinishFlag(Boolean finishFlag) {
        this.finishFlag = finishFlag;
    }

    public Integer getSubjectId() {
        return subjectId;
    }

    public void setSubjectId(Integer subjectId) {
        this.subjectId = subjectId;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public Boolean getVipFlag() {
        return vipFlag;
    }

    public void setVipFlag(Boolean vipFlag) {
        this.vipFlag = vipFlag;
    }

    public GroupType getGroupType() {
        return groupType;
    }

    public void setGroupType(GroupType groupType) {
        this.groupType = groupType;
    }

    public StandardEnum getStandardFlag() {
		return standardFlag;
	}

	public void setStandardFlag(StandardEnum standardFlag) {
		this.standardFlag = standardFlag;
	}

	public String getMusicScoreContent() {
		return musicScoreContent;
	}

	public void setMusicScoreContent(String musicScoreContent) {
		this.musicScoreContent = musicScoreContent;
	}

	public String getMusicScoreName() {
		return musicScoreName;
	}

	public void setMusicScoreName(String musicScoreName) {
		this.musicScoreName = musicScoreName;
	}

	public String getMusicScoreId() {
		return musicScoreId;
	}

	public void setMusicScoreId(String musicScoreId) {
		this.musicScoreId = musicScoreId;
	}

	public ImSendTypeEnum getMsgType() {
		return msgType;
	}

	public void setMsgType(ImSendTypeEnum msgType) {
		this.msgType = msgType;
	}

	public Date getSubmitTime() {
		return submitTime;
	}

	public void setSubmitTime(Date submitTime) {
		this.submitTime = submitTime;
	}

	public boolean isExtra() {
		return extra;
	}

	public void setExtra(boolean extra) {
		this.extra = extra;
	}

	public String getAvatar() {
		return avatar;
	}

	public void setAvatar(String avatar) {
		this.avatar = avatar;
	}

	@ApiModelProperty(value = "备注",required = false)
	private String remark;

	@ApiModelProperty(value = "提交状态",required = false)
	private YesOrNoEnum status;

	@ApiModelProperty(value = "是否已经回复",required = false)
	private YesOrNoEnum isReplied;

	private Integer isRepliedTimely;

	@ApiModelProperty(value = "是否已查看")
	private YesOrNoEnum isView;

	public Integer getIsRepliedTimely() {
		return isRepliedTimely;
	}

	public void setIsRepliedTimely(Integer isRepliedTimely) {
		this.isRepliedTimely = isRepliedTimely;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public Long getCourseScheduleId() {
		return courseScheduleId;
	}

	public void setCourseScheduleId(Long courseScheduleId) {
		this.courseScheduleId = courseScheduleId;
	}

	public String getUserName() {
		return userName;
	}

	public void setUserName(String userName) {
		this.userName = userName;
	}

	public YesOrNoEnum getIsView() {
		return isView;
	}

	public void setIsView(YesOrNoEnum isView) {
		this.isView = isView;
	}

	public YesOrNoEnum getIsReplied() {
		return isReplied;
	}

	public void setIsReplied(YesOrNoEnum isReplied) {
		this.isReplied = isReplied;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public YesOrNoEnum getStatus() {
		return status;
	}

	public void setStatus(YesOrNoEnum status) {
		this.status = status;
	}

	public void setId(Long id){
		this.id = id;
	}
	
	public Long getId(){
		return this.id;
	}

	public Integer getUserId() {
		return userId;
	}

	public void setUserId(Integer userId) {
		this.userId = userId;
	}

	public void setCourseHomeworkId(Long courseHomeworkId){
		this.courseHomeworkId = courseHomeworkId;
	}
	
	public Long getCourseHomeworkId(){
		return this.courseHomeworkId;
	}
			
	public void setAttachments(String attachments){
		this.attachments = attachments;
	}
	
	public String getAttachments(){
		return this.attachments;
	}
			
	public void setScore(Integer score){
		this.score = score;
	}
	
	public Integer getScore(){
		return this.score;
	}
			
	public void setCreateTime(java.util.Date createTime){
		this.createTime = createTime;
	}
	
	public java.util.Date getCreateTime(){
		return this.createTime;
	}
			
	public void setUpdateTime(java.util.Date updateTime){
		this.updateTime = updateTime;
	}
	
	public java.util.Date getUpdateTime(){
		return this.updateTime;
	}
			
	public CourseHomework getCourseHomework() {
		return courseHomework;
	}

	public void setCourseHomework(CourseHomework courseHomework) {
		this.courseHomework = courseHomework;
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this);
	}
}
